@ SVC Call trampoline.
@ All system calls have to take args from the 
@ Stack, so this code figures out which stack,
@ and passes it along to the routine as r0
@ We're now in supervisor mode, so r0-r4 are 
@ free for us to use as we see fit.

.text
.syntax unified
.thumb_func     @  Make sure the linker puts it in the table.
.global SVCHandler
SVCHandler:

	@ bkpt #0

	tst	lr,#0x4		@ Figure out which stack
	ite	eq
	mrseq	r0,msp		@ Main stack
	mrsne	r0,psp		@ Process/Thread Stack

	ldr	r1,[r0,#24]	@ Get the stacked PC
	ldrb	r1,[r1,#-2]	@ Extract the svc call number

	@ Range Checking goes here.

	ldr  r2,=syscall_table 
	ldr  r2, [r2, r1, LSL #2]

	mov pc,r2
	
	@ No more code...  We've already jumped.

	.align 1
syscall_table:
	.extern __SAPI_Version
	.word	__SAPI_Version		@ SVC 0
	.extern __SAPI_StreamPutChar
	.word	__SAPI_StreamPutChar	@ SVC 1
	.extern __SAPI_StreamGetChar
	.word	__SAPI_StreamGetChar	@ SVC 2
	.extern __SAPI_StreamCharsAvail
	.word	__SAPI_StreamCharsAvail	@ SVC 3
	.word	0	@ SVC 4
	.word	0	@ SVC 5
	.word	0	@ SVC 6
	.word	0	@ SVC 7
	.word	0	@ SVC 8
	.extern __SAPI_GetUsage
	.word	__SAPI_GetUsage		@ SVC 9
	.extern __SAPI_GetTimeMS
	.word	__SAPI_GetTimeMS	@ SVC 10
	.word	0	@ SVC 11
	.word	0	@ SVC 12
	.word	0	@ SVC 13
	.word	0	@ SVC 14
syscall_table_end:

.end

