// Sockpuppet API Code.  This is our
// shim for Forth.  Should be very easy to port
// to exotic environments.
//
// Copyright(C) 2012 Robert Sexton
//
// These are all declared void because they return by modifying
// the return stack.

#include <inc/hw_memmap.h>

// Return an API Version
void __SAPI_Version(long *frame) {
	frame[0] = 0x0201;
	return;
	}

static const int uart_ports[] = {
	UART0_BASE,
	UART1_BASE,
	UART2_BASE };

// Eventually this will support multiple
// descriptors for multiple ports, etc,
// but for now, its a place-holder
// Args:
// Descriptor - Which port we're referring to.
// data - the byte to write to the port.
void __SAPI_StreamPutChar(long *frame) {
	if (frame[0] != 0 ) frame[0] = 0;
  	// UARTCharPut(uart_ports[frame[0]],'.');
  	UARTCharPut(uart_ports[frame[0]],frame[1]);
	return;
	}

void __SAPI_StreamGetChar(long *frame) {
	if (frame[0] != 0 ) frame[0] = 0 ;
	frame[0] = UARTCharGet(uart_ports[frame[0]]);
	}

// Check to see if there is a char available
// For now, just directly ask Stellarisware
void __SAPI_StreamCharsAvail(long *frame) {
	if (frame[0] != 0 ) frame[0] = 0 ;
	frame[0] = UARTCharsAvail(uart_ports[frame[0]]);
	}

// Return the current value of the ms counter.
extern ticks_ms;
void __SAPI_GetTimeMS(long *frame) {
	frame[0] = ticks_ms;	
	}

// Return the number of CPU cycles in the last second.
extern usage;
void __SAPI_GetUsage(long *frame) {
	frame[0] = usage;	
	}


